
clear
use data_files/resultssets.dta

// no computation here -- this is a dataset of results
// E.g. created using a 'postfile' -> 'post' procedure
// or -statsby- or -collapse-

gsort mn 
gen pos = _n
gen xplab = 19800

// prepare graph layout -- use local for clarity  
loc gropts ///
	 scheme(s1mono) plotregion(style(none) margin(medium))  ///   sober scheme
	 yscale(off) /// no y-axes
	 title("A dot plot (by hand)" , position(11)) ///
	 xlabel(25000(5000)40000, axis(2)) xlabel( "", axis(1))
 
loc legend ///
	legend(order(21 20) label(20 "Mean score") label( 21 "Median score") ///
	position(4) ring(0) )
		
// generate the grid lines		 
forv i=1/`=_N' {
  loc scatteris `scatteris' (scatteri `i' 22400 `i' 40000 , recast(line) lpattern(dot) lcolor(gs12))
}		 
		 
twoway ///
	`scatteris' ///
	(scatter pos xplab if gender==1 , msym(none) mlabel(name) mlabpos(right) mlabcolor(red)) ///  
	(scatter pos xplab if gender==2 , msym(none) mlabel(name) mlabpos(right) mlabcolor(blue)) ///  
	(pcspike pos mn pos med   , lcolor(gs9) xaxis(1 2)) ///  
	(scatter pos mn    , msym(d) mcolor(black) ) ///  
	(scatter pos med   , msym(Oh) mcolor(black) )   ///
	, `gropts' `legend' saving(example3.gph, replace)

	
sort med
gen pos2 = _n
gen xplab2 = 40200
		 
twoway ///
	`scatteris' ///
	(scatter pos xplab2 if gender==1 , msym(none) mlabel(name) mlabpos(right) mlabcolor(red)) ///  
	(scatter pos xplab2 if gender==2 , msym(none) mlabel(name) mlabpos(right) mlabcolor(blue)) ///  
	(scatter pos2 xplab if gender==1 , msym(none) mlabel(name) mlabpos(right) mlabcolor(red)) ///  
	(scatter pos2 xplab if gender==2 , msym(none) mlabel(name) mlabpos(right) mlabcolor(blue)) ///  
	(pcspike pos mn pos2 med   , lcolor(gs9) xaxis(1 2)) ///  
	(scatter pos mn    , msym(d) mcolor(black) ) ///  
	(scatter pos2 med   , msym(Oh) mcolor(black) )   ///
	, `gropts' saving(example3b.gph, replace) ///
	xscale(range(19000 43000) axis(1 2)) legend(off) title("or a bootstrap(?) plot" , position(11)) ///
 

	
	
	
    
exit

	