clear

* This requires installation of software package by Maurizio Pisati
* -spmap- + -spkde- and -spgrid- (findit ...)


* Generate a 100x100 grid with spgrid

spgrid, shape(square) xdim(100)   ///
 xrange(0 1) yrange(0 1)            ///
 dots replace                       ///
 cells("2D-GridCells.dta")          ///
 points("2D-GridPoints.dta")

 
use "data_files/ale_canazei_pvk.dta", clear // NB; this file can not be distributed
xtset pid wave

*  Normalize variables in the range [0,1]
gen X = L.y  if year==2008
gen Y = y    if year==2008
su X [aw=pwgt]
replace X = X/r(mean)
su Y [aw=pwgt]
replace Y = Y/r(mean)
replace X  = (X-0) / (4-0)
replace Y  = (Y-0) / (4-0)
mylabels 0(.5)4, myscale((@-0) / (4 - 0)) local(XLAB)
mylabels 0(.5)4, myscale((@-0) / (4 - 0)) local(YLAB)
keep X Y 
drop if missing(X+Y)
save "xy.dta", replace

*  Estimate the bivariate probability density function

spkde using "2D-GridPoints.dta",   ///
 xcoord(X) ycoord(Y)              ///
 bandwidth(fbw) fbw(0.2) dots     ///
 saving("2D-Kde.dta", replace)

 
* Draw the density plot

use "2D-Kde.dta", clear
recode lambda (.=0)
spmap lambda using "2D-GridCells.dta",      ///
 id(spgrid_id) clnum(16) fcolor(Terrain)   ///
 ocolor(none ..) legend(off)               ///
 freestyle aspectratio(1)                  ///
 title("Bivariate income distribution") ///
 xtitle("Income 2003 / mean 2003")               ///
 xlab(`XLAB')                               ///
 ytitle("Income 2008 / mean 2008")                       ///
 ylab(`YLAB', angle(0)) ///
 plotregion(style(none))  graphregion(style(none)) legend(off)  scheme(s1color)   
 graph display ,  xsize(4.2) ysize(5)
 graph save example6.gph, replace

    
exit

	